<template>
    <div class="content-grid content-grid--subpage">
        <Breadcrumbs :title="t(`routes.admin.children.regles.add.name`)" />
        <BackLinkTitle :title="t(`routes.admin.children.regles.add.name`)" />
        <Card>
            <RegleForm ref="regleFormRef" @formSubmit="handleSubmit" />
        </Card>
    </div>
</template>

<script lang="ts" setup>
    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";
    import RegleForm from "@/components/regles/RegleForm.vue";
    import Card from "@/components/layout/Card.vue";
    import { ref } from "vue"
    import { useI18n } from "vue3-i18n";
    import { Regle } from "@/types/entities";
    import { notifyError, notifySuccess } from "@/notify";
    import { useRegleService } from "@/inversify.config";
    import { ICreateRegleRequest } from "@/types/requests/createRegleRequest";
    import { useRouter } from "vue-router";

    const { t } = useI18n()
    const router = useRouter();
    const regleService = useRegleService();
    const regleFormRef = ref();

    async function handleSubmit(regle: Regle) {
        let succeededOrNotResponse = await regleService.createRegle(regle as ICreateRegleRequest)
        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.regle.add.success'))
            setTimeout(() => {
                router.back();
            }, 1500);
        } else {
            console.log(succeededOrNotResponse);
            let errorMessages = succeededOrNotResponse.getErrorMessages('validation.regle.add');
            if (errorMessages.length == 0)
                notifyError(t('validation.book.add.errorOccured'))
            else {
                if (regleFormRef.value) {
                    regleFormRef.value.mettreRouge();
                }
                notifyError(errorMessages[0])

            }
        }
    }
</script>
